﻿using AutoMapper;
using Models.Table;
using Repositories.IRepository.IBussiness;
using Repositories.IRepository.IUnitOfWork;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Repositories.Repository.Bussiness
{
    public class PoliceFingerRepository : BaseRepository<PoliceFinger>, IPoliceFingerRepository
    {
        protected readonly ILocalSugarUnitOfWork _suger;
        public IMapper mapper;
        public PoliceFingerRepository(ILocalSugarUnitOfWork sugarUnitOfWork) : base(sugarUnitOfWork)
        {
            _suger = sugarUnitOfWork;
        }

        public async Task<bool> UpdateFinger(string policeId, List<PoliceFinger> fingers)
        {
            using (var context = _suger.GetDbClient())
            {
                try
                {
                    fingers.ForEach(s =>
                    {
                        s.policeId = policeId;
                        s.createTime = DateTime.Now;
                        s.updateTime = DateTime.Now;
                    });

                    //新增或更新
                    var x = context.Storageable(fingers).ToStorage();
                    x.AsInsertable.ExecuteCommand();
                    x.AsUpdateable.WhereColumns(s => new { s.id, s.fingerNum })//查询字段
                        .UpdateColumns(s => new { s.fingerInfo, s.updateTime })//更新字段
                        .IgnoreColumns(s => new { s.policeId, s.fingerNum, s.createTime })//不更新字段
                        .ExecuteCommand();

                    return true;
                }
                catch (Exception e)
                {
                    return false;
                }
            }
        }
    }
}
